;     Weihnachtsmann Polonese
; -------------------------------
;  Entry for the XMas-PureContest
;
;     (c)Y2K3 benny /
;          weltenkonstrukteur.de
;
; -------------------------------
;
; proc_DoGame()

; Struktur von den Weihnachtsmnnern
Structure Santa
  delay.l
  state.l
  x.l
  y.l
  dy.f
  jumpstate.l
EndStructure

;Struktur der Bodenhindernisse
Structure Ground
  id.l
  x.l
  y.l
EndStructure

Dim Boden.Ground(10)
Dim Santas.Santa(5)

Global levelspeed, Bodenstueck, anzsantas
levelspeed = 2
Bodenstueck = 0
anzsantas = 5

#SantasY = 260

;Log
Boden(0)\id = 3
Boden(0)\x = 700
Boden(0)\y = 294
;Snowman
Boden(1)\id = 4
Boden(1)\x = 700
Boden(1)\y = 264
;Sign
Boden(2)\id = 5
Boden(2)\x = 700
Boden(2)\y = 215

; Parallax Front
Boden(4)\id = 10
Boden(4)\x = 1
Boden(4)\y = 285
Boden(5)\id = 10
Boden(5)\x = 735
Boden(5)\y = 285

; Parallax Back
Boden(6)\id = 12
Boden(6)\x = 0
Boden(6)\y = 180
Boden(7)\id = 13
Boden(7)\x = 650
Boden(7)\y = 180

;Muecke
Boden(8)\id = 6
Boden(8)\x = 1500
Boden(8)\y = 100

;Bonus-Punkte
Boden(9)\id = 7
Boden(9)\x = 1000
Boden(9)\y = 100

;Santa Eins
Santas(0)\delay = 5
Santas(0)\state = 0
Santas(0)\x = 280
Santas(0)\y = #SantasY
Santas(0)\dy = 0.0
Santas(0)\jumpstate = 0

;Santa Zwei
Santas(1)\delay = 5
Santas(1)\state = 0
Santas(1)\x = 220
Santas(1)\y = #SantasY
Santas(1)\dy = 0.0
Santas(1)\jumpstate = 0

;Santa Drei
Santas(2)\delay = 5
Santas(2)\state = 0
Santas(2)\x = 160
Santas(2)\y = #SantasY
Santas(2)\dy = 0.0
Santas(2)\jumpstate = 0

;Santa Vier
Santas(3)\delay = 5
Santas(3)\state = 0
Santas(3)\x = 100
Santas(3)\y = #SantasY
Santas(3)\dy = 0.0
Santas(3)\jumpstate = 0

;Santa Fnf
Santas(4)\delay = 5
Santas(4)\state = 0
Santas(4)\x = 40
Santas(4)\y = #SantasY
Santas(4)\dy = 0.0
Santas(4)\jumpstate = 0


;###########################################################################
; DoGame

Procedure DoGame(xmaus.l, ymaus.l)

  Shared levelspeed, Bodenstueck, GameFont, score, fadeout,gamestate

  ClearScreen (0,0,0)
  
; Mouse Movement -> Dummy Sprite
  DisplayTransparentSprite(20, xmaus-5, ymaus-20)
; Display StarBackground [bewegt sich nicht]
  DisplaySprite(11, 0, 0)
; Display BergSiloutte
  For dummy=6 To 7
    DisplayTransparentSprite(Boden(dummy)\id, Boden(dummy)\x, Boden(dummy)\y)
    Boden(dummy)\x = Boden(dummy)\x - (levelspeed / 2)
    If Boden(dummy)\x < -645
      Boden(dummy)\x = 630
    EndIf
  Next dummy
    
; Display Polonese
  For numsantas=0 To 4
    If Santas(numsantas)\state <> -1
      DisplayTransparentSprite(Santas(numsantas)\state, Santas(numsantas)\x, Santas(numsantas)\y)
    EndIf
  Next numsantas
; Display Bodenhindernis
  DisplayTransparentSprite(Boden(Bodenstueck)\id, Boden(Bodenstueck)\x, Boden(Bodenstueck)\y)
; Display Lufthindernis
  DisplayTransparentSprite(Boden(8)\id, Boden(8)\x, Boden(8)\y+Random(3))
; Display Bonus-Paket
  DisplayTransparentSprite(Boden(9)\id, Boden(9)\x, Boden(9)\y)
; Display Prallax Front // Ganz vorne, deswegen zuletzt gemalt
   For dummy=4 To 5
     DisplayTransparentSprite(Boden(dummy)\id, Boden(dummy)\x, Boden(dummy)\y)
     Boden(dummy)\x = Boden(dummy)\x - levelspeed
     If Boden(dummy)\x < -715
       Boden(dummy)\x = 700
     EndIf
   Next dummy

; Lufthindernis
  If Boden(8)\x < - 40
    Boden(8)\x = 1500 + Random(500)
    tester = Boden(8)\x - Boden(9)\x
    If tester < 0
      tester = tester * (-1)
    EndIf
    If tester < 100
      Boden(8)\x = Boden(8)\x + 220
    EndIf
    Boden(8)\y = 50 + Random(100)
  Else
    Boden(8)\x = Boden(8)\x - levelspeed
  EndIf

; Bonuspaket
  If Boden(9)\x < - 50
    Boden(9)\x = 2000 + Random(3000)
    Boden(9)\y = 50 + Random(100)
  Else
    Boden(9)\x = Boden(9)\x - levelspeed
  EndIf
  
; Bodenhindernis aus'm Bild ???
  If Boden(Bodenstueck)\x < -30
    Bodenstueck = Random(2)  
    Boden(Bodenstueck)\x = 700 + Random(500)
    tester = Boden(8)\x - Boden(Bodenstueck)\x
    If tester < 0
      tester = tester * (-1)
    EndIf
    If tester < 100
      Boden(Bodenstueck)\x = Boden(Bodenstueck)\x + 220
    EndIf    
;    Bodenstueck = Random(2)
  Else
    Boden(Bodenstueck)\x = Boden(Bodenstueck)\x - levelspeed
  EndIf
    
; Let Santa Walk  
  If Santas(0)\delay = 0
    Santas(0)\delay = 5
    For numsantas=0 To 4
      If Santas(numsantas)\state = -1
        Continue
      ElseIf Santas(numsantas)\state = 2
        Santas(numsantas)\state = 0
        score = score + 1
      Else
        Santas(numsantas)\state = Santas(numsantas)\state + 1
     EndIf  
    Next numsantas
  Else
    Santas(0)\delay = Santas(0)\delay - 1
  EndIf

; Kollision Check .. Santa + Boden 
For level=0 To 4
  If Santas(level)\y < #SantasY
    Santas(level)\dy = Santas(level)\dy + 0.5
  ElseIf Santas(level)\y >= #SantasY
    Santas(level)\y = #SantasY 
    Santas(level)\dy = 0
    Santas(level)\jumpstate = 0
  EndIf
  
  If Santas(level)\jumpstate=0  And Santas(level)\state > -1 And SpriteCollision(Santas(level)\state, Santas(level)\x, Santas(level)\y, 20, xmaus-5, ymaus-30)=#True
    Santas(level)\jumpstate = 1
    PlaySound(1)
    Santas(level)\dy = Santas(level)\dy - 16
  EndIf

  ; Kollision mit Bodenhindernis  
  If Santas(level)\jumpstate=0 And Santas(level)\state > -1 And SpriteCollision(Santas(level)\state, Santas(level)\x, Santas(level)\y, Boden(Bodenstueck)\id, Boden(Bodenstueck)\x, Boden(Bodenstueck)\y)=#True
      PlaySound(3)
      Santas(level)\state = -1
      anzsantas = anzsantas - 1
  EndIf
 
  ; Kollision mit Lufthindernis ?
  If Santas(level)\state > -1 And SpriteCollision(Santas(level)\state, Santas(level)\x, Santas(level)\y, Boden(8)\id, Boden(8)\x, Boden(8)\y)=#True
    PlaySound(3)
    Santas(level)\state = -1
    anzsantas = anzsantas - 1
  EndIf

  If Santas(level)\state > -1 And SpriteCollision(Santas(level)\state, Santas(level)\x, Santas(level)\y, Boden(9)\id, Boden(9)\x, Boden(9)\y)=#True
      score = score + 500
      PlaySound(2)
      Boden(9)\x = 2000 + Random(3000)
      Boden(9)\y = 50 + Random(100)      
  EndIf
  
  Santas(level)\y = Santas(level)\y + Santas(level)\dy
Next level

  levelspeed = 2 + (score / 2000)

  StartDrawing(ScreenOutput())
    DrawingMode(1)
    DrawingFont(GameFont)
    FrontColor(255,255,255)
    Locate(10, 335)
    DrawText("Score: "+Str(score))
    If anzsantas = 0
      Locate( 320, 335)
      DrawText("Game Over")
      gamestate = 3
    EndIf
  StopDrawing()
  
  If gamestate = 3
    Start3D()
        fadeout = fadeout + 1
        DisplaySprite3D( 18, 0, 0 , fadeout)
        DisplaySprite3D( 18, 257, 0, fadeout)
        DisplaySprite3D( 18, 514, 0, fadeout)
        DisplaySprite3D( 18, 0, 257, fadeout)
        DisplaySprite3D( 18, 257, 257, fadeout)
        DisplaySprite3D( 18, 514, 257, fadeout)
    Stop3D()
  EndIf
  
  If fadeout > 250
    gamestate = 0
    fadeout = 0
    score = 0
    anzsantas = 5
    levelspeed = 2
    Bodenstueck = 0
    modvol = 60
    PlayMXMModule()
    MXMModuleVolume(60)
;Log
Boden(0)\id = 3
Boden(0)\x = 700
Boden(0)\y = 294
;Snowman
Boden(1)\id = 4
Boden(1)\x = 700
Boden(1)\y = 264
;Sign
Boden(2)\id = 5
Boden(2)\x = 700
Boden(2)\y = 215

; Parallax Front
Boden(4)\id = 10
Boden(4)\x = 1
Boden(4)\y = 285
Boden(5)\id = 10
Boden(5)\x = 735
Boden(5)\y = 285

; Parallax Back
Boden(6)\id = 12
Boden(6)\x = 0
Boden(6)\y = 180
Boden(7)\id = 13
Boden(7)\x = 650
Boden(7)\y = 180

;Muecke
Boden(8)\id = 6
Boden(8)\x = 1500
Boden(8)\y = 100

;Bonus-Punkte
Boden(9)\id = 7
Boden(9)\x = 1000
Boden(9)\y = 100

;Santa Eins
Santas(0)\delay = 5
Santas(0)\state = 0
Santas(0)\x = 280
Santas(0)\y = #SantasY
Santas(0)\dy = 0.0
Santas(0)\jumpstate = 0

;Santa Zwei
Santas(1)\delay = 5
Santas(1)\state = 0
Santas(1)\x = 220
Santas(1)\y = #SantasY
Santas(1)\dy = 0.0
Santas(1)\jumpstate = 0

;Santa Drei
Santas(2)\delay = 5
Santas(2)\state = 0
Santas(2)\x = 160
Santas(2)\y = #SantasY
Santas(2)\dy = 0.0
Santas(2)\jumpstate = 0

;Santa Vier
Santas(3)\delay = 5
Santas(3)\state = 0
Santas(3)\x = 100
Santas(3)\y = #SantasY
Santas(3)\dy = 0.0
Santas(3)\jumpstate = 0

;Santa Fnf
Santas(4)\delay = 5
Santas(4)\state = 0
Santas(4)\x = 40
Santas(4)\y = #SantasY
Santas(4)\dy = 0.0
Santas(4)\jumpstate = 0    
  EndIf

EndProcedure

; ExecutableFormat=Windows
; DisableDebugger
; EOF